<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripItemResult_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripItemResult_V5 extends AbstractStructArrayBase
{
    /**
     * The TripItemResult_V5
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripItemResult_V5[]
     */
    public $TripItemResult_V5;
    /**
     * Constructor method for ArrayOfTripItemResult_V5
     * @uses ArrayOfTripItemResult_V5::setTripItemResult_V5()
     * @param \StructType\TripItemResult_V5[] $tripItemResult_V5
     */
    public function __construct(array $tripItemResult_V5 = array())
    {
        $this
            ->setTripItemResult_V5($tripItemResult_V5);
    }
    /**
     * Get TripItemResult_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripItemResult_V5[]|null
     */
    public function getTripItemResult_V5()
    {
        return isset($this->TripItemResult_V5) ? $this->TripItemResult_V5 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripItemResult_V5 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripItemResult_V5 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripItemResult_V5ForArrayConstraintsFromSetTripItemResult_V5(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripItemResult_V5TripItemResult_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfTripItemResult_V5TripItemResult_V5Item instanceof \StructType\TripItemResult_V5) {
                $invalidValues[] = is_object($arrayOfTripItemResult_V5TripItemResult_V5Item) ? get_class($arrayOfTripItemResult_V5TripItemResult_V5Item) : sprintf('%s(%s)', gettype($arrayOfTripItemResult_V5TripItemResult_V5Item), var_export($arrayOfTripItemResult_V5TripItemResult_V5Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripItemResult_V5 property can only contain items of type \StructType\TripItemResult_V5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripItemResult_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_V5[] $tripItemResult_V5
     * @return \ArrayType\ArrayOfTripItemResult_V5
     */
    public function setTripItemResult_V5(array $tripItemResult_V5 = array())
    {
        // validation for constraint: array
        if ('' !== ($tripItemResult_V5ArrayErrorMessage = self::validateTripItemResult_V5ForArrayConstraintsFromSetTripItemResult_V5($tripItemResult_V5))) {
            throw new \InvalidArgumentException($tripItemResult_V5ArrayErrorMessage, __LINE__);
        }
        if (is_null($tripItemResult_V5) || (is_array($tripItemResult_V5) && empty($tripItemResult_V5))) {
            unset($this->TripItemResult_V5);
        } else {
            $this->TripItemResult_V5 = $tripItemResult_V5;
        }
        return $this;
    }
    /**
     * Add item to TripItemResult_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_V5 $item
     * @return \ArrayType\ArrayOfTripItemResult_V5
     */
    public function addToTripItemResult_V5(\StructType\TripItemResult_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripItemResult_V5) {
            throw new \InvalidArgumentException(sprintf('The TripItemResult_V5 property can only contain items of type \StructType\TripItemResult_V5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripItemResult_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripItemResult_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripItemResult_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripItemResult_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripItemResult_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripItemResult_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripItemResult_V5
     */
    public function getAttributeName()
    {
        return 'TripItemResult_V5';
    }
}
